﻿Function Cls()
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
End Function
Function StartOrthoGL(Width:Int, Height:Int, depth:Int = 0, hertz:Int = 60)
	EndGraphics()
	GLGraphics(Width, Height, depth, hertz) 'OpenGL fenster initialisieren - danke blitzmax! :)
	
	glMatrixMode(GL_PROJECTION)  ' Projektionsmatrix auswählen.
	glLoadIdentity() 'Zurücksetzen der Matrix
	
	glOrtho(-ResX / 2, ResX / 2, ResY / 2, -ResY / 2, 0, 128)
	
	glMatrixMode(GL_MODELVIEW)
'
'	Const ResX:Int = 1024, ResY:Int = 768
'	Const SekTileCnt:Int = ResY / 16
'	Const TileSize:Int = 16
	glTranslated(-(SekTileCnt * TileSize / 2), -ResY / 2, 0)
'	glTranslated(-ResX / 2, -ResY / 2, 0)
End Function
Function RecieveGLError(str:String = "")
	If Len(str) > 0 Then str = " Zusatz:: " + str
	Local glErr:Int = glGetError()
	
'	Select glErr
''		Case GL_INVALID_ENUM Print "GL ERROR:: GL_INVALID_ENUM" + str
''		Case GL_INVALID_VALUE Print "GL ERROR:: GL_INVALID_ENUM" + str
''		Case GL_INVALID_OPERATION Print "GL ERROR:: GL_INVALID_OPERATION" + str
''		Case GL_STACK_OVERFLOW Print "GL ERROR:: GL_STACK_OVERFLOW" + str
''		Case GL_STACK_UNDERFLOW Print "GL ERROR:: GL_STACK_UNDERFLOW" + str
''		Case GL_OUT_OF_MEMORY Print "GL ERROR:: GL_OUT_OF_MEMORY" + str
'	End Select
End Function
Function pyth:Float(x1:Float, y1:Float, x2:Float, y2:Float) 'abstand nach phytagoras
Return (Sqr ((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2)))
End Function
Function pyth2:Float(x1:Float, y1:Float) 'abstand nach phytagoras
Return (Sqr ((x1) * (x1) + (y1) * (y1)))
End Function
Function Pixelweg:Float(x1:Float, y1:Float, x2:Float, y2:Float)
	Return Abs(x1 - x2) + Abs(y1 - y2)
End Function

Function GLDrawText(Text:String, x:Float, y:Float, ausrichtung:Int = 0, sizeX:Float = -1000, sizeY:Float = -1000)
'	If fontSeq<>graphicsSeq
	glPushMatrix()

	If sizeX = -1000 Then sizeX = 8
	If sizeY = -1000 Then sizeY = 16
	
	Select ausrichtung
		Case 0 'linksbündig! nixtun
		Case 1 'mittig! halbe text-breite nach links translaten!
			glTranslated((-Len(Text) * sizeX / 2.0), 0, 0)
		Case 2 'rechtsbündig! text-breite nach links translaten!
			glTranslated(-(Len(Text) * sizeX), 0, 0)
	End Select
	
	If Not fontTex
		Local pixmap:TPixmap=TPixmap.Create( 1024,16,PF_RGBA8888 )
		Local p:Byte Ptr=IncbinPtr( "gldrawtextfont.bin" )
		For Local y:Int = 0 Until 16
			For Local x:Int = 0 Until 96
				Local b:Byte = p[x]
				For Local n:Int = 0 Until 8
					If b & (1 Shl n)
						pixmap.WritePixel x*8+n,y,~0
					Else
						pixmap.WritePixel x*8+n,y,0
					EndIf
				Next
			Next
			p:+96
		Next
		fontTex = GLTexFromPixmap(pixmap)
		fontSeq=graphicsSeq
	EndIf
	
	glEnable GL_TEXTURE_2D
	glBindTexture GL_TEXTURE_2D,fontTex
	
	For Local i:Int = 0 Until Text.length
		Local c:Int = Text[i] - 32
		If c >= 0 And c < 96
			Const adv#=8/1024.0
			Local t#=c*adv;
			glBegin GL_QUADS
			glTexcoord2f t,0
			glVertex2f x,y
			glTexcoord2f t+adv,0
			glVertex2f x + sizeX, y
			glTexcoord2f t+adv,1
			glVertex2f x + sizeX, y + sizeY
			glTexcoord2f t,1
			glVertex2f x, y + sizeY
			glEnd
		EndIf
		x:+sizeX
	Next

	glPopMatrix()
End Function

Function ResetGlobals(config:ConfigFile = Null)
	Local tmpConf:Int = 0
	If config = Null Then
		config:ConfigFile = ConfigFile.LoadConfig("Config.ini")
		tmpConf = 1
	'	Print "TMP CONFIG"
	EndIf
	musikLevel:Float = config.ReadEntry("Sound", "Musiklevel").ToInt() / 100.0
	soundLevel:Float = config.ReadEntry("Sound", "Soundlevel").ToInt() / 100.0
	spielerZahl:Int = Config.ReadEntry("General", "Spielerzahl").ToInt()
	kiZahl:Int = Config.ReadEntry("General", "KIzahl").ToInt()
	
'	Print musikLevel
	If tmpConf Then ConfigFile.Close(config)
	If musikChannel Then musikChannel.SetVolume(musikLevel)

End Function
Function SFX:TChannel(index:Int)
	If Len(sounds) > index Then
	If sounds[index] Then
		Local ret:TChannel = sounds[index].Play()
		ret.SetVolume(soundLevel)
		'der faulheit wegen..
		If index = 0 Then ret.SetRate(Rnd(0.7, 1.3))
		Return ret
	Else
'		Print "sound nicht vorhanden"
	EndIf
	Else
	'	Print "index out of bounds D:"
	EndIf
EndFunction
Function GetAngleDiff:Float(fromX:Float, fromY:Float, toX:Float, toY:Float, fromAngle:Float)

	Local WorldWinkel:Float = ATan2(toY - fromY, toX - fromX)
	
	WorldWinkel = (WorldWinkel + 360) Mod 360
	
	Local Zielwinkel:Float = WorldWinkel - fromAngle
	
	If Zielwinkel < - 180 Then
		Zielwinkel:+360
	EndIf
	If Zielwinkel > 180 Then
		Zielwinkel:-360
	End If
	
	Return Zielwinkel
	
End Function

Function GetVictim:TSnake(skip_snake:TSnake, distanz:Float = -1)
	Local retSnake:TSnake = Null
	Local dist:Float = 1000000
	Local tmpList:TList = Mitspieler.Copy()
	For Local plyr:TSpieler = EachIn Mitspieler
		If plyr.index = skip_snake.owner.index Then
			tmpList.Remove(plyr)
			Exit
		End If
	Next
	If distanz = -1 Then
		'distanz = -1 bedeutet den normalen aufruf. 
		'distanz > 0 bedeutet, es soll ein näheres ziel gefunden werden, wie das vorgeschlagene
		dist = 1000000


	
	For Local rot:TSnakeRotten = EachIn tmpList
		If rot.time > 30 Then
		If Abstand(rot.posX, rot.posY, skip_snake.posX, skip_snake.posy) < 75 Then Return rot
		Local tmpDist:Float = Abstand(rot.posX, rot.posY, skip_snake.posX, skip_snake.posy, dist)
		If tmpDist < dist Then
			'diese schlange ist näher dran!
			retSnake = rot
			dist = tmpDist
		End If
		EndIf
	Next
	
	'first: Den nächsten spieler bestimmen!
	For Local plyr:TSpieler = EachIn tmpList
		If plyr.schlange Then
		Local tmpDist:Float = Abstand(plyr.schlange.posX, plyr.schlange.posY, skip_snake.posX, skip_snake.posy, dist)
		If tmpDist < dist Then
			'diese schlange ist näher dran!
			retSnake = plyr.schlange
			dist = tmpDist
		End If
		EndIf
	Next
	
	Else
		dist = distanz
		For Local rot:TSnakeRotten = EachIn tmpList
			If rot.time > 30 Then
			If Abstand(rot.posX, rot.posY, skip_snake.posX, skip_snake.posy) < 100 Then Return rot
			Local tmpDist:Float = Abstand(rot.posX, rot.posY, skip_snake.posX, skip_snake.posy, dist)
			If tmpDist < dist Then
				'diese schlange ist näher dran!
				retSnake = rot
				dist = tmpDist
			End If
			EndIf
		Next
		
		'first: Den nächsten spieler bestimmen!
		For Local plyr:TSpieler = EachIn tmpList
			If plyr.schlange Then
			Local tmpDist:Float = Abstand(plyr.schlange.posX, plyr.schlange.posY, skip_snake.posX, skip_snake.posy, dist)
			If tmpDist < dist Then
				'diese schlange ist näher dran!
				retSnake = plyr.schlange
				dist = tmpDist
			End If
			EndIf
		Next
	End If
	
	Return retSnake
End Function
Function Abstand:Float(x1:Float, y1:Float, x2:Float, y2:Float, max_abstand:Float = -1)
	If max_abstand = -1 Then
	'direkt den pythagoras rotzen!
		Return pyth(x1, y1, x2, y2)
	Else
		If Pixelweg(x1, y1, x2, y2) < max_abstand * 4 Then
			Local abst:Float = pyth(x1, y1, x2, y2)
			If abst <= max_abstand Then
				Return abst
			Else
				Return 100000 'unmöglicher wert!
			End If
		End If
	EndIf
End Function
'Rem
'	bbdoc: Liefert einen Pointer auf den part oder NULL für snakehead! ~n accuracy gibt an, wie genau geprüft werden soll (1 skippt zb jeden 2ten part! 2 skippt immer 2 parts, 3 skippt 3...!)
'End rem
'Function GetClosestPart:TSnakePart(destX:Float, destY:Float, snake:TSnake, accuracy:Int = 1)
'	'holt den part, der am nächsten dran ist!
'	
'	Local index:Int = 0
'	Local maxIndex:Int = snake.parts.Count()
'	
'	Local retPart:TSnakePart = Null
'	Local retPartDist:Float = 10000000
'	Local tmpDist:Float = 0
'	
'	While index <= maxIndex
'		tmpDist = pyth(destX, destY)
'	WEnd
'	
'	
'End Function