﻿Rem
	bbdoc: Ein erneuter ansatz, daten aus eienr Konfigurationsdatei zu laden und zu speichern.
EndRem
Type ConfigFile

	Field FileName:String = ""
	Field Data:TMap = CreateMap()
	Field changed:Int = 0
	
	Method New()
	End Method
	Rem
		bbdoc: GetHeaderData liefert einen String - Array mit datenpäärchen aus der Headersektion.
	EndRem
	Method GetHeaderData:String[] (HeaderName:String)
		Return String(Self.Data.ValueForKey(HeaderName)).Split("|")
	End Method
	Rem
		bbdoc: ReadEntrag liefert den Wert eines Eintrags einer entsprechenden headersektion! "" wenn nicht gefunden/header falsch! todo: Chr(0) für falscher header, Chr(1) für falscher eintrag returnen!
	End Rem
	Method ReadEntry:String(HeaderName:String, EintragName:String)
		Local retStr:String = ""
	'	Print "Read entry wurde aufgerufen - Headername: " + HeaderName + " Eintragname: " + eintragname
		If Self.Data.Contains(HeaderName) Then
		'	Print "Header gefunden!"
			'Search it baby, one more time :)
			Local strArr:String[] = String(Self.Data.ValueForKey(HeaderName)).Split("|")
			For Local Pos:Int = 0 Until Len(strArr) Step 2
				If strArr[Pos] = EintragName Then
					retStr = strArr[Pos + 1]
					Exit
				End If
			Next
		End If
		Return retStr
	End Method
	Rem
		bbdoc: WriteData schreibt einen Eintrag+Wert pack in eine Headersektion und setzt 'changed' auf 1 -> Inidatei wird neu gebaut, wenn Close() ausgeführt wird!
	End Rem
	Method WriteData(HeaderName:String, EintragName:String, wert:String)
		If Self.Data.Contains(HeaderName) Then
			Local found:Int = 0
			Local strArr:String[] = String(Self.Data.ValueForKey(HeaderName)).split("|")
			Local newStr:String = ""
			For Local Pos:Int = 0 Until Len(strArr) Step 2
				If strArr[Pos] = EintragName Then
					strArr[Pos + 1] = wert
					found = 1
				End If
				'das bauen des strings schonmal mitlaufen lassen, um eine weitere For zu vermeiden!
				newStr = newStr + strArr[Pos] + "|" + strArr[Pos + 1] + "|"
			Next
			If found = 1 Then
				'Alles cool, wert wurde geändert -> string einbauen!
				Self.Data.Insert(HeaderName, newStr[..Len(newStr) - 1])
			Else
				'not found -> Eintragen!
				newStr = newStr + EintragName + "|" + wert
				Self.Data.Insert(HeaderName, newStr)
			EndIf
		Else
			'Header ist nicht drin! neu anlegen!
			Self.Data.Insert(HeaderName, EintragName + "|" + wert)
		End If
		Self.changed = 1
	End Method
	
	Rem
		bbdoc: Close als funktion. Cleart die TMap, null sie und nullt das objekt. -> Delete. Wenn WriteData() vorher ausgeführt wurde, wird die inidatei neu geschrieben!!
	End Rem
	Function Close(Conf:ConfigFile)
		If Conf.changed = 1 Then
			'es wurde reingeschrieben! Dh speichern!
			Local stream:TStream = WriteFile(Conf.fileName)
			Local data:String = ""
			Local strArr:String[]
			Local Pos:Int = 0
			For Local header:String = EachIn Conf.data.Keys()
				data = String(Conf.data.ValueForKey(header))
				strArr = data.Split("|")
				stream.WriteLine("[" + header + "]")
				For Pos = 0 Until Len(strArr) Step 2
					stream.WriteLine(strArr[Pos] + " = " + strArr[Pos + 1])
				Next
				stream.WriteLine("")
			Next
			stream.Close()
		End If
		Conf.data.Clear()
		Conf.data = Null
		Conf = Null
		'speicher brav freigeben!
	End Function
	Rem
		bbdoc: Lädt eine Konfigurationsdatei und \nspeichert sich in einem Internen Array!
	EndRem
	Function LoadConfig:ConfigFile(File:String)
		Local conf:ConfigFile = New ConfigFile
		
		conf.FileName = File
		
		If FileSize(File) < 0 Then CreateFile(File)
		
		Local stream:TStream = ReadFile(File)

		Local currentLine:String = ""
		Local currHeaderData:String = ""
		
		Local oldHeaderName:String = ""
		Local tmpPos:Int = 0
		
		While Not Eof(stream)
			currentLine = stream.ReadLine()
			If Len(currentLine) > 0 And currentLine[0] = 91 Then ' Das erste zeichen des string ist ein [ ! -> Neue headerdatei!
				If oldHeaderName = "" Then
					'nixtun da doof xD
				Else
					'alten header eintragen!
					conf.Data.Insert(oldHeaderName, currHeaderData[..Len(currHeaderData) - 1])
			'		Print "Alter HeaderName: " + oldHeaderName + "\nNeuer HeaderName: " + currentLine[1..Len(currentLine) - 1] + " data gesammelt: " + currHeaderData[..Len(currHeaderData) - 1]
				EndIf
				'alten header auf neuen namen ändern
				oldHeaderName = currentLine[1..Len(currentLine) - 1]
				currHeaderData = ""
			Else
				'Das ist keine neue Header sektion!
				If Len(currentLine) > 1 Then
					tmpPos = currentLine.Find("=")
			
					currHeaderData = currHeaderData + currentLine[..tmpPos].Trim() + "|" + currentLine[tmpPos + 1..].Trim() + "|"
				EndIf
			EndIf

		Wend
		'alles durch: Letzten header eintragen!
		If oldHeaderName = "" Then
			'nixtun da doof xD
		Else
			'alten header eintragen!
			conf.Data.Insert(oldHeaderName, currHeaderData[..Len(currHeaderData) - 1])
		'	Print "Alter HeaderName: " + oldHeaderName + "\n data gesammelt: " + currHeaderData[..Len(currHeaderData) - 1]
		EndIf
	'	Print "Loading done!"
	'	For Local str:String = EachIn MapValues(conf.Data)
	'		Print str
	'	Next
		Return conf
	End Function
End Type
