﻿glewInit()
'TSektor.CreateVertexBuffer()

Const iVBO:Int = 0
Const iTEXTUR:Int = 1
Const iCOLOR:Int = 2
Const iTRIS:Int = 3

Type TSektor
	Field x:Int = 0
	Field y:Int = 0
	
	Field Slots:Int[,] = New Int[sektilecnt, sektilecnt]
	Field light:Int[,] = New Int[sekTileCnt, sekTileCnt]

	Field vboToUpdate:Int = 1 | 2 | 4 | 8 'Vertex, Textur,Color,Tris
	Field vboBuffer:Int[] = New Int[4]
	Field iboBuffer:Int[] = [0]

	Field Verts:Float[]
	Field Tris:Int[]
	Field Colors:Byte[]
	Field Tex1:Float[]
	
	Field VertsCount:Int
	Field lastVert:Int = 0
	Field triCount:Int
	Field lastTri:Int = 0
	
	Field testIBO:Int[] = New Int[6]
	
	Field CollisionMask:Byte[,] = New Byte[sektilecnt * tilesize, sektilecnt * tilesize]
	
	rem
	bbdoc: PrepareVBOArray richtet die entsprechende größe der Arrays ein, um sie korrekt mit VBO nutzen zu können.
	End Rem
	Method PrepareVBOArray(desired_vertex_count:Int)
	
		'Init der arrays:
		Local vertexSize:Int = desired_vertex_count * 3
		Local triCnt:Int = desired_vertex_count * 2 'Triangles ftw :)
		Local colorCnt:Int = desired_vertex_count * 3
		Local UVcnt:Int = desired_vertex_count * 2
		
		'Pro vertex 3 koords - XYZ
		'Pro Vertex 1 eintrag im Tri array
		'Pro vertex 3 farben - RGB
		'Pro vertex 2 uv koordinaten 
		Self.Verts = New Float[vertexSize]
		Self.Tris = New Int[triCnt]
		Self.Colors = New Byte[colorCnt]
		Self.Tex1 = New Float[UVcnt]
	End Method
	Method New()
		'initialisiert meine arrays in ihrer länge.
		Self.PrepareVBOArray(SekTileCnt * SekTileCnt * 4) '64x64 Kacheln - á 4 Vertex!
		
		Local v1:Int = 0
		Local v2:Int = 0
		Local v3:Int = 0
		Local v4:Int = 0
		
		Local col:Int = 0
		For Local y:Int = 0 Until SekTileCnt
		For Local x:Int = 0 Until SekTileCnt
			If x = 0 Or x = SekTileCnt - 1 Or y = 0 Or y = SekTileCnt - 1 Then
				Self.Slots[x, y] = 1
			Else
				Self.Slots[x, y] = 0
			EndIf
			Local col:Int = 0
			'erstellen der 4 verts einer Kachel - vX ist der index des verts! ist quasie index_xKoordinate/3 
			Local u:Float = 0.2 * Self.Slots[x, y]
			Local v:Float = 0.0
			v1 = Self.AddVertex(TileSize * x, TileSize * y, 0, u, v, col, col, col) 'UV: 0,0
			v2 = Self.AddVertex(TileSize * x + TileSize, TileSize * y, 0, u + 0.2, v, col, col, col) 'UV: 1,0
			v3 = Self.AddVertex(TileSize * x + TileSize, TileSize * y + TileSize, 0, u + 0.2, v + 0.2, col, col, col) 'UV: 1,.25
			v4 = Self.AddVertex(TileSize * x, TileSize * y + TileSize, 0, u, v + 0.2, col, col, col) 'UV: 0, .25
			
			'je 3 Verts zu einem tris adden.

			Self.AddTri(v1, v2, v3)
			Self.AddTri(v1, v3, v4)
		'	Print "neue kachel erstellt"
		Next
		Next
		For Local x:Int = 0 Until SekTileCnt * TileSize
		For Local y:Int = 0 Until SekTileCnt * TileSize
			Self.CollisionMask[x, y] = 0
		Next
		Next
		'Licht überprüfen! todo :D
		
		'Buffer einrichten!
		glGenBuffersARB(3, VarPtr(Self.vboBuffer[0])) '3 buffer anlegen!
		glGenBuffersARB(1, VarPtr(Self.iboBuffer[0])) 'ibo buffer anlegen!
		
		'Buffer in die graka laden + erstellen - nur wichtig für vbo etc.
		glBindBufferARB(GL_ARRAY_BUFFER_ARB, Self.vboBuffer[iVBO])
		glBufferDataARB(GL_ARRAY_BUFFER_ARB, SizeOf(Self.Verts), VarPtr(Self.Verts[0]), GL_STATIC_DRAW_ARB)
		
		glBindBufferARB(GL_ARRAY_BUFFER_ARB, Self.vboBuffer[iTEXTUR])
		glBufferDataARB(GL_ARRAY_BUFFER_ARB, SizeOf(Self.Tex1), VarPtr(Self.Tex1[0]), GL_DYNAMIC_DRAW_ARB)
		
		glBindBufferARB(GL_ARRAY_BUFFER_ARB, Self.vboBuffer[iCOLOR])
		glBufferDataARB(GL_ARRAY_BUFFER_ARB, SizeOf(Self.Colors), VarPtr(Self.Colors[0]), GL_STATIC_DRAW_ARB)
		
		glBindBufferARB(GL_ELEMENT_ARRAY_BUFFER_ARB, Self.iboBuffer[0])
		glBufferDataARB(GL_ELEMENT_ARRAY_BUFFER_ARB, SizeOf(Self.Tris), VarPtr(Self.Tris[0]), GL_STATIC_DRAW_ARB)
		'buffer laden ende.
		
		'aktiven buffer auf 0.
		glBindBufferARB(GL_ARRAY_BUFFER_ARB, 0)
		glBindBufferARB(GL_ELEMENT_ARRAY_BUFFER_ARB, 0)
	End Method
	rem
	bbdoc: AddVertex fügt einen vertex in die Arrays ein.
	end rem
	Method AddVertex:Int(x:Float = 0.0, y:Float = 0.0, z:Float = 0.0, u:Float = 0.0, v:Float = 0.0, r:Byte = 255, g:Byte = 255, b:Byte = 255)
	'Vertices! ganz sicher pflicht! :)
		Self.Verts[(Self.lastVert * 3) + 0] = x
		Self.Verts[(Self.lastVert * 3) + 1] = y
		Self.Verts[(Self.lastVert * 3) + 2] = z
	'	Print "Adde vertexposis an stelle: " + ((Self.lastVert * 3) + 0) + " X  mit werT: " + x + " - Stelle: " + ((Self.lastVert * 3) + 1) + " Y mit wert: " + y + " - Stelle: " + ((Self.lastVert * 3) + 2) + " Z mit wert: " + z
	'Color! Standartfarbe 255,255,255!
		Self.Colors[(Self.lastVert * 3) + 0] = r
		Self.Colors[(Self.lastVert * 3) + 1] = g
		Self.Colors[(Self.lastVert * 3) + 2] = b
	'UV! :)
		Self.Tex1[(Self.lastVert * 2) + 0] = u
		Self.Tex1[(Self.lastVert * 2) + 1] = v
	'Finally: Index der Vertices erhöhen und counter zurückgeben.
		Self.lastVert:+1
		Return Self.lastVert - 1
	End Method
	Method AddTri:Int(v1:Int, v2:Int, v3:Int)
		Self.Tris[(Self.lastTri * 3) + 0] = v1
		Self.Tris[(Self.lastTri * 3) + 1] = v2
		Self.Tris[(Self.lastTri * 3) + 2] = v3
		
		Self.lastTri:+1
		
		Return Self.lastTri - 1
	End Method
	
	Method Save()
		
	End Method
	
	Function Load:TSektor(x:Int, y:Int)
		Local sek:TSektor = New TSektor
		
		Return sek
	End Function
	
	Function Create:TSektor(x:Int, y:Int)
		Local sek:TSektor = New TSektor
		
		sek.x = x
		sek.y = y
		
	'	sek.FillVBO()
		
		Return sek
	End Function
	
	Method Draw:Int()

	'	glTranslated((ResX/2)-(SekPixelSize / 2),0, 0)
	'	glBindBufferARB(GL_ARRAY_BUFFER_ARB, Self.vboBuffer[iCOLOR]) 'Col buffer!
	'	RecieveGLError("col einbinden")
	'	glColorPointer(3, GL_UNSIGNED_BYTE, 0, Null)
	'	RecieveGLError "col ptr"
		
		glBindBufferARB(GL_ARRAY_BUFFER_ARB, Self.vboBuffer[iVBO])
	'	glBindBufferARB(GL_ARRAY_BUFFER_ARB, Self.vboBuffer[iVBO]) 'VERTEX buffer!
		RecieveGLError "vbo einbinden"
		glVertexPointer(3, GL_FLOAT, 0, Null)
		RecieveGLError "vbo ptr"
	
	
		glBindBufferARB(GL_ARRAY_BUFFER_ARB, Self.vboBuffer[iTEXTUR])
		RecieveGLError "tex einbinden"
		glTexCoordPointer(2, GL_FLOAT, 0, Null)
		RecieveGLError "tex ptr"
		


	'		glBindBufferARB(GL_ELEMENT_ARRAY_BUFFER_ARB, Self.iboBuffer[0])
			RecieveGLError("ibo einbinden")
			glDrawElements(GL_TRIANGLES, SekTileCnt*SekTileCnt*6, GL_UNSIGNED_INT, VarPtr(Self.Tris[0]))

			
		RecieveGLError "draw elements"
		glBindBufferARB(GL_ARRAY_BUFFER_ARB, 0)
		RecieveGLError "bind buffer 0"
		

	End Method

	
	Method updateVBO:Int()
		
	End Method
rem	
	Method FillVBO:Int()
	
		Local minX:Int = 0'((-Self.x * SekPixelSize) - i + (resX / 2)) / tilesize
		Local maxX:Int = 63'((-Self.x * SekPixelSize) - i - (resX / 2)) / tilesize
		Local minY:Int = 0'(-Self.y * SekPIxelSize - a + (resY / 2)) / tilesize
		Local maxY:Int = 63'(-Self.y * SekPIxelSize - a - (resY / 2)) / tilesize

		Local x:Int = 0
		Local y:Int = 0
		
		'------------------------ EXPERIMENTAL --------------------
		'Größe der vertexdaten:
		Local iSize:Int = SekTileCnt * SekTileCnt * 4 * NumOfVertexPos
		Self.VertexArray = New Float[iSize]'New Float[iSize]
		
		'Größe der IBO daten:
		Local iIBOsize:Int = SekTilecnt * SekTileCnt * 2 * 3
		Self.iboArr = New Int[iIBOsize]
		
		Local vuibo:Int[] = New Int[2]
		Local vc:Int = 0
		Local ic:Int = 0
		TSektor.CreateViBOBuffer:Int(VarPtr(VuIBO[0]), Self.VertexArray, Self.iboArr, (vc), (ic))
		Self.vuibo = vuibo
		Self.vertexCount = vc
		Self.iboSize = ic
		
		Print "ouz create vibobuffer - :" + VertexArray[0]
		Print "out create vibobuffer - :" + VertexArray[55]
		glGenBuffersARB(3, VarPtr(Self.buffer[0])) 'neuen Buffer anlegen -> Color, Textur, Textur 2!
		
		
	'	RecieveGLError "gen buffer vbo daten"
	'	glGenBuffersARB(1, VarPtr(Self.ibo[0])) 'index buffer anlegen
'RecieveGLError "gen buffer ibo daten"
		
		
		'Größe der farbdaten: (häää?)
		Local colSize2:Int = SekTileCnt * SekTileCnt * 4 * 3
		'Größe der Texturdaten: 
		Local iTexSize:Int = SekTileCnt * SekTileCnt * 4 * 2

		

		Self.texArr = New Float[iTexSize] '1 uv pro Vertex pro kachel.
		Self.colArr = New Float[colSize2] 'color array!
		Self.texArr2 = New Float[iTexSize]
		
		
		Local color:Float = 0
		Local xpos:Float = 0, ypos:Float = 0
		For y = minY To maxY
			ypos = y * TileSize' + (Self.y * (SekPixelSize)) + a ' / ResY '+ a
			For x = minX To maxX
				xpos = x * TileSize '+ (Self.x * (SekPixelSize)) + i
			
				
				color = 1.0 ' / ((Self.y + 2) Mod 2) '1.0'1.0/((x * y) Mod 127) 'Self.light[x, y]
				If x = y Then
					color = 0.8
				ElseIf (SekTileCnt - x) = y Then
					color = 0.8

				'Links!
				ElseIf (y > x And SekTileCnt - y > x) Then
					color =.9
				'rechts!
				ElseIf (x > y And SekTileCnt - x < y) Then
					color =.95
				
				'nix -.-
				ElseIf (x > SekTileCnt - y And SekTileCnt - x > y) Then
					color = 0.0
				'UNTEN!
				ElseIf (x < y) Then' And SekTileCnt - y > x) Then
					color = 0.75
				
				'OBEN!
				ElseIf (x > y And SekTileCnt - x > y) Then
					color =.65
				Else
					color = 0.0
				EndIf
			'	If y = maxX / 2 Then color = 1.0
			end rem
				rem
			'	Print "" + (8 * (y * SekTileCnt + x))
				vboArr[offsetVertex1 + vboSize + ofstU] = 0.0;vboArr[offsetVertex1 + vboSize + ofstV] = 0.0
				vboArr[offsetVertex1 + vboSize + ofstR] = color; vboArr[offsetVertex1 + vboSize + ofstG] = color; vboArr[offsetVertex1 + vboSize + ofstB] = color
				vboArr[offsetVertex1 + vboSize + ofstX] = xpos
				vboArr[offsetVertex1 + vboSize + ofstY] = ypos
				vboArr[offsetVertex1 + vboSize + ofstZ] = 0

				Print (offsetVertex1 + vboSize + ofstU)
				Print (offsetVertex1 + vboSize + ofstV)
				Print (offsetVertex1 + vboSize + ofstR)
				Print (offsetVertex1 + vboSize + ofstG)
				Print (offsetVertex1 + vboSize + ofstB)
				Print (offsetVertex1 + vboSize + ofstX)
				Print (offsetVertex1 + vboSize + ofstY)
				Print (offsetVertex1 + vboSize + ofstZ)
			'	Print (offsetVertex1 + 32 * (y * SekTileCnt + x) + ofstU)
			'	Print (offsetVertex1 + 32 * (y * SekTileCnt + x) + ofstV)
			'	Print (offsetVertex1 + 32 * (y * SekTileCnt + x) + ofstR)
			'	Print (offsetVertex1 + 32 * (y * SekTileCnt + x) + ofstG)
			'	Print (offsetVertex1 + 32 * (y * SekTileCnt + x) + ofstB)
			'	Print (offsetVertex1 + 32 * (y * SekTileCnt + x) + ofstX)
			'	Print (offsetVertex1 + 32 * (y * SekTileCnt + x) + ofstY)
			'	Print (offsetVertex1 + 32 * (y * SekTileCnt + x) + ofstZ)
			'	Print (offsetVertex2 + 32 * (y * SekTileCnt + x) + ofstU)

				vboArr[offsetVertex2 + vboSize + ofstU] = 1;vboArr[offsetVertex2 + vboSize + ofstV] = 0.0
				vboArr[offsetVertex2 + vboSize + ofstR] = color; vboArr[offsetVertex2 + vboSize + ofstG] = color; vboArr[offsetVertex2 + vboSize + ofstB] = color
				vboArr[offsetVertex2 + vboSize + ofstX] = xpos + TileSize
				vboArr[offsetVertex2 + vboSize + ofstY] = ypos
				vboArr[offsetVertex2 + vboSize + ofstZ] = 0
				
				vboArr[offsetVertex3 + vboSize + ofstU] = 1;vboArr[32 * (y * SekTileCnt + x) + ofstV] = 0.25
				vboArr[offsetVertex3 + vboSize + ofstR] = color; vboArr[offsetVertex3+vboSize + ofstG] = color; vboArr[offsetVertex3+vboSize + ofstB] = color
				vboArr[offsetVertex3 + vboSize + ofstX] = xpos + TileSize
				vboArr[offsetVertex3 + vboSize + ofstY] = ypos + TileSize
				vboArr[offsetVertex3 + vboSize + ofstZ] = 0
				
				vboArr[offsetVertex4 + vboSize + ofstU] = 0.0;vboArr[offsetVertex4 + vboSize + ofstV] = 0.25
				vboArr[offsetVertex4 + vboSize + ofstR] = color; vboArr[offsetVertex4 + vboSize + ofstG] = color; vboArr[offsetVertex4 + vboSize + ofstB] = color
				vboArr[offsetVertex4 + vboSize + ofstX] = xpos
				vboArr[offsetVertex4 + vboSize + ofstY] = ypos + 0.25
				vboArr[offsetVertex4 + vboSize + ofstZ] = 0
				
				iboArr[iboSize + 0] = ((vboSize + offsetVertex1) / 8)
				iboArr[iboSize + 1] = ((vboSize + offsetVertex2) / 8)
				iboArr[iboSize + 2] = ((vboSize + offsetVertex3) / 8)
				
				iboArr[iboSize + 3] = ((vboSize + offsetVertex1) / 8)
				iboArr[iboSize + 4] = ((vboSize + offsetVertex3) / 8)
				iboArr[iboSize + 5] = ((vboSize + offsetVertex4) / 8)
				
				vboSize:+32
				
		'		Print "V1: " + ((offsetVertex1 + 32 * (y * SekTileCnt + x)) / 8)
		'		Print "V2: " + ((offsetVertex2 + 32 * (y * SekTileCnt + x)) / 8)
		'		Print "V3: " + ((offsetVertex3 + 32 * (y * SekTileCnt + x)) / 8)
		'		Print "V4: " + ((offsetVertex4 + 32 * (y * SekTileCnt + x)) / 8)

				iboSize:+6
				End rem
'----------------------------------------------------------
				'vertex1!
rem
				
				colArr[colSize + 0] = color
				colArr[colSize + 1] = color
				colArr[colSize + 2] = color
				
				

				texArr[texSize + 0] = 0.0
				texArr[texSize + 1] =.25
				texArr2[texSize + 0] = 0.0
				texArr2[texSize + 1] =.5
				texSize:+2;colSize:+3
'----------------------------------------------------------
				'vertex2!

				
				colArr[colSize + 0] = color
				colArr[colSize + 1] = color
				colArr[colSize + 2] = color
				
				

				
				texArr[texSize + 0] = 1.0
				texArr[texSize + 1] =.25
				texArr2[texSize + 0] = 1.0
				texArr2[texSize + 1] =.5

				texSize:+2;colSize:+3
				
'----------------------------------------------------------
				'vertex3!

				colArr[colSize + 0] = color
				colArr[colSize + 1] = color
				colArr[colSize + 2] = color
				
				

				
				texArr[texSize + 0] = 1
				texArr[texSize + 1] =.5
				texArr2[texSize + 0] = 1.0
				texArr2[texSize + 1] =.75
				texSize:+2;colSize:+3
				
'----------------------------------------------------------
				'vertex4!
				
				colArr[colSize + 0] = color
				colArr[colSize + 1] = color
				colArr[colSize + 2] = color
				

				
				texArr[texSize + 0] = 0.0
				texArr[texSize + 1] =.5
				texArr2[texSize + 0] = 0.0
				texArr2[texSize + 1] =.75

				texSize:+2;iboSize:+6;colSize:+3
		
			Next
		Next

		'vboSize:-8
	'	iboSize:-6
		'Print "ibosize:" + iboSize
	'	Self.vboArr = Self.vboArr[..vboSize]
	'	Self.iboArr = Self.iboArr[..iboSize]
	'	Self.texArr = Self.texArr[..texSize]
	'	Self.colArr = Self.colArr[..colSize]
	'	Print "TexSize: " + Len(Self.texArr) + " - Erwartet wird: " + (SekTileCnt * SekTileCnt * 8)
		
	'	Print "IBO size: " + SizeOf(Self.iboArr) + " errechnet: " + (64 * 64 * 2 * 3)
		
	'	Print "Anzahl Tris: " + iboSize
'		Print "Anzahl Verts: " + vboSize
	'	Print "Anzahl UV's: " + texSize
	'	Print "Anzahl Color's: " + colSize
'		
	'	Print "**compare**"
	'	Print "Ibo: " + (iboSize / 3.0 * 2.0) + " Verts erwartet."
'		Print "Verts: " + (vboSize / 3.0)
	'	Print "UV: " + (texSize / 2.0) + " Verts erwartet."
	'	Print "Color: " + (colSize / 3.0) + " Verts erwartet."
		'VBO ptr holen!
		


		
		'TEX ptr holen!
		glBindBufferARB(GL_ARRAY_BUFFER_ARB, Self.buffer[1])
		RecieveGLError "init tex buffer - binden"
		glBufferData(GL_ARRAY_BUFFER_ARB, SizeOf(Self.texArr), VarPtr(Self.texArr[0]), GL_STATIC_DRAW_ARB)
		RecieveGLError "init tex buffer - füllen"
		
		glBindBufferARB(GL_ARRAY_BUFFER_ARB, Self.buffer[2])
		glBufferData(GL_ARRAY_BUFFER_ARB, SizeOf(Self.texArr2), VarPtr(Self.texArr2[0]), GL_STATIC_DRAW_ARB)
		'COL ptr holen!
		glBindBufferARB(GL_ARRAY_BUFFER_ARB, Self.buffer[0])
		RecieveGLError "init col buffer - binden"
		glBufferData(GL_ARRAY_BUFFER_ARB, SizeOf(Self.colArr), VarPtr(Self.colArr[0]), GL_STATIC_DRAW_ARB)
		RecieveGLError "init col buffer - füllen"


		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER_ARB, 0)
		RecieveGLError "init buffers donw -> Bindbuffer 0!"
	'	MemCopy(floatPtr, Self.vboArr, vboSize)

		
	'	MemCopy(vboPtr, vboArr, iSize + colSize)
	'	glUnmapBuffer(GL_ARRAY_BUFFER)
		
	'	glTexCoordPointer(2, GL_FLOAT, 0, 0)
	'	glVertexPointer(2, GL_FLOAT, 0, 2)
	'	glColorPointer(3, GL_FLOAT, 0, 4)

	'DebugStop()
	end rem	
	Rem
		For Local y:Int = 0 Until SekTileCnt
			'xpos erneut prüfen!
			Local ypos:Int = y * tileSize + (Self.y * (SekPixelSize)) + a
			If ypos > (ResY / 2) Then Return 0 ' er ist zu weit rechts! also kann gleich beendet werden!!
			If ypos < - ((ResY / 2) + TileSize) Then 'er ist zu weit links!
				y = -(((ResY / 2) + ypos) / TileSize)
				If y >= 64 Or y < 0 Then Continue
				ypos = y * TileSize + (Self.y * (SekPixelSize)) + a
			EndIf
			Local xD:Int = 0
			Local Last:Int = -1
			For Local x:Int = 0 Until SekTileCnt
				'licht überprüfen! Ist tile "unsichtbar?" -> continue!
			'	If Self.light[x, y] <= 0 Then Continue
				
				'ypos erneut prüfen!
				Local xpos:Int = x * tileSize + (Self.x * (SekPixelSize)) + i
				If xpos > (ResX / 2) Then Exit 'er ist viel zu weit unten!
				If xpos < - ((ResX / 2) + TileSize) Then 'er ist viel zu weit oben!
					x = -(((ResX / 2) + xpos) / TileSize)
					If x >= 64 Or x < 0 Then Continue
					xpos = x * TileSize + (Self.x * (SekPixelSize)) + i
				EndIf
				If Self.light[x, y] <= 0 Then Continue
			'	Print "Licht XYZ: " + Self.light[x, y]
				glColor3b(Self.light[x, y], Self.light[x, y], Self.light[x, y])
			'	DrawImage(xpos, ypos, TileSize, TileSize)

				Local tex:Int = Self.slots[x, y] & $0000ff
				Local tile:Int = Self.Slots[x, y] Shr 8

				If lastTex <> tex Then
					glBindTexture(GL_TEXTURE_2D, tex)
					lastTex = tex
				'	Print x + " " + y

				EndIf
				If Last = -1 Then
					Last = tile
					xD:+1
				'	Print "TILE: " + tile + " xD: " + xD
				ElseIf Last <> tile Or xpos >= (ResX / 2) Then
					'draw!
					glBegin(GL_QUADS)
						glTexCoord2f(0, .25) ;glVertex2f(xpos - (TileSize * xD), ypos)
						glTexCoord2f(xD, .25) ;glVertex2f(xpos + TileSize, ypos)
						glTexCoord2f(xD, .5) ;glVertex2f(xpos + TileSize, ypos + TileSize)
						glTexCoord2f(0, .5) ;glVertex2f(xpos - (TileSize * xD), ypos + TileSize)
					glEnd()
				'	Print "DRAW!! xD: " + xD
					Last = -1
					counter:+1
				Else
					xD:+1
				EndIf


				
			Next
		Next
		End rem
'	End Method
	
End Type

Function AbstandSqr:Int(x1:Int, y1:Int, x2:Int, y2:Int) 'abstand nach phytagoras
Return (Sqr (((x1 - x2) ^ 2) + (y1 - y2) ^ 2))
End Function